// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_GleanCaptchadetectionMetrics_h
#define mozilla_GleanCaptchadetectionMetrics_h

#include "mozilla/glean/bindings/MetricTypes.h"

namespace mozilla::glean {

namespace captcha_detection {
  /**
   * generated from captcha_detection.arkoselabs_oc
   * Number of times the ArkoseLabs was loaded since last ping submission.
   */
  constexpr impl::CounterMetric arkoselabs_oc(4503);

  /**
   * generated from captcha_detection.arkoselabs_oc_pbm
   * Number of times the ArkoseLabs was loaded since last ping submission.
   */
  constexpr impl::CounterMetric arkoselabs_oc_pbm(4504);

  /**
   * generated from captcha_detection.arkoselabs_pc
   * How many times the ArkoseLabs challenge was successfully completed.
   */
  constexpr impl::CounterMetric arkoselabs_pc(4505);

  /**
   * generated from captcha_detection.arkoselabs_pc_pbm
   * How many times the ArkoseLabs challenge was successfully completed.
   */
  constexpr impl::CounterMetric arkoselabs_pc_pbm(4506);

  /**
   * generated from captcha_detection.arkoselabs_pf
   * How many times the ArkoseLabs challenge was failed.
   */
  constexpr impl::CounterMetric arkoselabs_pf(4507);

  /**
   * generated from captcha_detection.arkoselabs_pf_pbm
   * How many times the ArkoseLabs challenge was failed.
   */
  constexpr impl::CounterMetric arkoselabs_pf_pbm(4508);

  /**
   * generated from captcha_detection.arkoselabs_solutions_required
   * The number of solutions required to complete the ArkoseLabs challenge.
   */
  constexpr impl::CustomDistributionMetric arkoselabs_solutions_required(4509);

  /**
   * generated from captcha_detection.arkoselabs_solutions_required_pbm
   * The number of solutions required to complete the ArkoseLabs challenge.
   */
  constexpr impl::CustomDistributionMetric arkoselabs_solutions_required_pbm(4510);

  /**
   * generated from captcha_detection.cloudflare_turnstile_cc
   * Number of times the Cloudflare Turnstile challenge was successfully completed since last ping submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_cc(4511);

  /**
   * generated from captcha_detection.cloudflare_turnstile_cc_pbm
   * Number of times the Cloudflare Turnstile challenge was successfully completed since last ping submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_cc_pbm(4512);

  /**
   * generated from captcha_detection.cloudflare_turnstile_cf
   * Number of times the Cloudflare Turnstile challenge was failed since last ping submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_cf(4513);

  /**
   * generated from captcha_detection.cloudflare_turnstile_cf_pbm
   * Number of times the Cloudflare Turnstile challenge was failed since last ping submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_cf_pbm(4514);

  /**
   * generated from captcha_detection.cloudflare_turnstile_oc
   * Number of times the Cloudflare Turnstile challenge was loaded since last ping submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_oc(4515);

  /**
   * generated from captcha_detection.cloudflare_turnstile_oc_pbm
   * Number of times the Cloudflare Turnstile challenge was loaded since last ping submission.
   */
  constexpr impl::CounterMetric cloudflare_turnstile_oc_pbm(4516);

  /**
   * generated from captcha_detection.datadome_bl
   * How many times the Datadome blocked a user.
   */
  constexpr impl::CounterMetric datadome_bl(4517);

  /**
   * generated from captcha_detection.datadome_bl_pbm
   * How many times the Datadome blocked a user.
   */
  constexpr impl::CounterMetric datadome_bl_pbm(4518);

  /**
   * generated from captcha_detection.datadome_oc
   * Number of times the Datadome was loaded since last ping submission.
   */
  constexpr impl::CounterMetric datadome_oc(4519);

  /**
   * generated from captcha_detection.datadome_pc
   * How many times the user passed a Datadome puzzle.
   */
  constexpr impl::CounterMetric datadome_pc(4520);

  /**
   * generated from captcha_detection.datadome_pc_pbm
   * How many times the user completed a Datadome puzzle.
   */
  constexpr impl::CounterMetric datadome_pc_pbm(4521);

  /**
   * generated from captcha_detection.datadome_ps
   * The number of times the Datadome puzzle was shown.
   */
  constexpr impl::CounterMetric datadome_ps(4522);

  /**
   * generated from captcha_detection.datadome_ps_pbm
   * The number of times the Datadome puzzle was shown.
   */
  constexpr impl::CounterMetric datadome_ps_pbm(4523);

  /**
   * generated from captcha_detection.google_recaptcha_v2_ac
   * Number of times the user completed a Google reCAPTCHA v2 challenge automatically since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_ac(4524);

  /**
   * generated from captcha_detection.google_recaptcha_v2_ac_pbm
   * Number of times the user completed a Google reCAPTCHA v2 challenge automatically since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_ac_pbm(4525);

  /**
   * generated from captcha_detection.google_recaptcha_v2_oc
   * Number of times the Google reCAPTCHA v2 was loaded since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_oc(4526);

  /**
   * generated from captcha_detection.google_recaptcha_v2_oc_pbm
   * Number of times the Google reCAPTCHA v2 was loaded since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_oc_pbm(4527);

  /**
   * generated from captcha_detection.google_recaptcha_v2_pc
   * Number of times the user completed a Google reCAPTCHA v2 puzzle since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_pc(4528);

  /**
   * generated from captcha_detection.google_recaptcha_v2_pc_pbm
   * Number of times the user completed a Google reCAPTCHA v2 puzzle since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_pc_pbm(4529);

  /**
   * generated from captcha_detection.google_recaptcha_v2_ps
   * Number of times the user has seen a Google reCAPTCHA v2 puzzle since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_ps(4530);

  /**
   * generated from captcha_detection.google_recaptcha_v2_ps_pbm
   * Number of times the user has seen a Google reCAPTCHA v2 puzzle since last ping submission.
   */
  constexpr impl::CounterMetric google_recaptcha_v2_ps_pbm(4531);

  /**
   * generated from captcha_detection.hcaptcha_ac
   * Number of times the user completed an hCaptcha challenge automatically.
   */
  constexpr impl::CounterMetric hcaptcha_ac(4532);

  /**
   * generated from captcha_detection.hcaptcha_ac_pbm
   * Number of times the user completed an hCaptcha challenge automatically.
   */
  constexpr impl::CounterMetric hcaptcha_ac_pbm(4533);

  /**
   * generated from captcha_detection.hcaptcha_oc
   * Number of times the hCaptcha was loaded since last ping submission.
   */
  constexpr impl::CounterMetric hcaptcha_oc(4534);

  /**
   * generated from captcha_detection.hcaptcha_oc_pbm
   * Number of times the hCaptcha was loaded since last ping submission.
   */
  constexpr impl::CounterMetric hcaptcha_oc_pbm(4535);

  /**
   * generated from captcha_detection.hcaptcha_pc
   * Number of times the user completed an hCaptcha puzzle.
   */
  constexpr impl::CounterMetric hcaptcha_pc(4536);

  /**
   * generated from captcha_detection.hcaptcha_pc_pbm
   * Number of times the user completed an hCaptcha puzzle.
   */
  constexpr impl::CounterMetric hcaptcha_pc_pbm(4537);

  /**
   * generated from captcha_detection.hcaptcha_ps
   * Number of times the hCaptcha puzzle was shown.
   */
  constexpr impl::CounterMetric hcaptcha_ps(4538);

  /**
   * generated from captcha_detection.hcaptcha_ps_pbm
   * Number of times the hCaptcha puzzle was shown.
   */
  constexpr impl::CounterMetric hcaptcha_ps_pbm(4539);

  /**
   * generated from captcha_detection.network_cookie_cookiebehavior
   * The user's cookie behavior setting at the time of data collection.
   */
  constexpr impl::StringMetric network_cookie_cookiebehavior(4540);

  /**
   * generated from captcha_detection.network_cookie_cookiebehavior_optinpartitioning
   * Whether the user has enabled cookie partitioning at the time of data collection.
   */
  constexpr impl::BooleanMetric network_cookie_cookiebehavior_optinpartitioning(4541);

  /**
   * generated from captcha_detection.network_cookie_cookiebehavior_optinpartitioning_pbm
   * Whether the user has enabled cookie partioning in PBM at the time of data collection.
   */
  constexpr impl::BooleanMetric network_cookie_cookiebehavior_optinpartitioning_pbm(4542);

  /**
   * generated from captcha_detection.pages_visited
   * The number of pages visited since the last ping submission.
   */
  constexpr impl::CounterMetric pages_visited(4543);

  /**
   * generated from captcha_detection.pages_visited_pbm
   * The number of pages visited since the last ping submission.
   */
  constexpr impl::CounterMetric pages_visited_pbm(4544);

  /**
   * generated from captcha_detection.privacy_fingerprintingprotection
   * Whether the user has enabled suspected fingerprinters protection at the time of data collection.
   */
  constexpr impl::BooleanMetric privacy_fingerprintingprotection(4545);

  /**
   * generated from captcha_detection.privacy_fingerprintingprotection_pbm
   * Whether the user has enabled suspected fingerprinters protection in PBM at the time of data collection.
   */
  constexpr impl::BooleanMetric privacy_fingerprintingprotection_pbm(4546);

  /**
   * generated from captcha_detection.privacy_resistfingerprinting
   * Whether the user has enabled resist fingerprinting at the time of data collection.
   */
  constexpr impl::BooleanMetric privacy_resistfingerprinting(4547);

  /**
   * generated from captcha_detection.privacy_resistfingerprinting_pbmode
   * Whether the user has enabled resist fingerprinting in PBM at the time of data collection.
   */
  constexpr impl::BooleanMetric privacy_resistfingerprinting_pbmode(4548);

  /**
   * generated from captcha_detection.privacy_trackingprotection_cryptomining_enabled
   * Whether the user has enabled cryptomining protection at the time of data collection.
   */
  constexpr impl::BooleanMetric privacy_trackingprotection_cryptomining_enabled(4549);

  /**
   * generated from captcha_detection.privacy_trackingprotection_enabled
   * Whether the user has enabled tracking protection at the time of data collection.
   */
  constexpr impl::BooleanMetric privacy_trackingprotection_enabled(4550);

  /**
   * generated from captcha_detection.privacy_trackingprotection_fingerprinting_enabled
   * Whether the user has enabled known fingerprinters protection at the time of data collection.
   */
  constexpr impl::BooleanMetric privacy_trackingprotection_fingerprinting_enabled(4551);

  /**
   * generated from captcha_detection.privacy_trackingprotection_pbm_enabled
   * Whether the user has enabled tracking protection in PBM at the time of data collection.
   */
  constexpr impl::BooleanMetric privacy_trackingprotection_pbm_enabled(4552);
}

} // namespace mozilla::glean

#endif // mozilla_GleanCaptchadetectionMetrics_h
