// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_GleanGleanMetrics_h
#define mozilla_GleanGleanMetrics_h

#include "mozilla/glean/bindings/MetricTypes.h"

namespace mozilla::glean {

namespace fog {
  /**
   * generated from fog.failed_idle_registration
   * True if we failed to register with the idle service. Absent otherwise.
   * Means IPC probably isn't working well.
   * Child-process data will likely be absent, or incomplete.
   */
  constexpr impl::BooleanMetric failed_idle_registration(4755);

  /**
   * generated from fog.initialization
   * Time the FOG initialization takes.
   */
  constexpr impl::TimespanMetric initialization(4756);

  /**
   * generated from fog.inits_during_shutdown
   * Counts the number of times init had to be called during shutdown.
   * Should never have a value for any session long enough to grow idle.
   */
  constexpr impl::CounterMetric inits_during_shutdown(4757);

  /**
   * generated from fog.max_pings_per_minute
   * Value of the configurable rate limit, in pings per minute, for Glean pings as set at init.
   */
  constexpr impl::QuantityMetric max_pings_per_minute(4758);
}

namespace fog_ipc {
  /**
   * generated from fog.ipc.buffer_sizes
   * The number and size of the IPC buffers being received over FOG IPC.
   */
  constexpr impl::MemoryDistributionMetric buffer_sizes(4759);

  /**
   * generated from fog.ipc.flush_durations
   * The length of time between asking the child processes for their
   * IPC buffers and all of them being received by the parent.
   */
  constexpr impl::TimingDistributionMetric flush_durations(4760);

  /**
   * generated from fog.ipc.flush_failures
   * The number of times we failed to flush all non-parent-process data,
   * throwing even partial results into the trash.
   * If this number is high, we might consider writing custom `MozPromise`-
   * handling code instead of using `MozPromise::All`.
   */
  constexpr impl::CounterMetric flush_failures(4761);

  /**
   * generated from fog.ipc.replay_failures
   * The number of times the ipc buffer failed to be replayed in the
   * parent process.
   */
  constexpr impl::CounterMetric replay_failures(4762);

  /**
   * generated from fog.ipc.shutdown_registration_failures
   * The number of times we tried to register shutdown flush routines for
   * content child processes, and failed (probably because there was no main
   * thread).
   * As a result there may be data loss from content child processes.
   * Large or rising number of clients experiencing this indicates we should
   * perhaps refactor content child shutdown in FOG to try harder to register
   * flush operations.
   * Will likely be obsoleted by bug 1641989.
   */
  constexpr impl::CounterMetric shutdown_registration_failures(4763);
}

} // namespace mozilla::glean

#endif // mozilla_GleanGleanMetrics_h
