//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PJSOracleChild.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/JSOracleChild.h"

#include "mozilla/dom/PJSValidatorChild.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {


auto PJSOracleChild::RecvPJSValidatorConstructor(PJSValidatorChild* actor) -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

auto PJSOracleChild::ProcessingError(
        Result aCode,
        const char* aReason) -> void
{
}

auto PJSOracleChild::ShouldContinueFromReplyTimeout() -> bool
{
    return true;
}

MOZ_IMPLICIT PJSOracleChild::PJSOracleChild() :
    mozilla::ipc::IToplevelProtocol("PJSOracleChild", kProtocolId, mozilla::ipc::ChildSide)
{
    MOZ_COUNT_CTOR(PJSOracleChild);
}

PJSOracleChild::~PJSOracleChild()
{
    MOZ_COUNT_DTOR(PJSOracleChild);
}

auto PJSOracleChild::ActorAlloc() -> void
{
    MOZ_RELEASE_ASSERT(XRE_IsUtilityProcess(), "Invalid process for `PJSOracleChild'");
    AddRef();
}

auto PJSOracleChild::ActorDealloc() -> void
{
    Release();
}

auto PJSOracleChild::ManagedPJSValidatorChild(nsTArray<PJSValidatorChild*>& aArr) const -> void
{
    mManagedPJSValidatorChild.ToArray(aArr);
}

auto PJSOracleChild::ManagedPJSValidatorChild() const -> const ManagedContainer<PJSValidatorChild>&
{
    return mManagedPJSValidatorChild;
}

auto PJSOracleChild::ManagedProtocolIds() const -> mozilla::Span<mozilla::ipc::ProtocolId const>
{
    static constexpr ::mozilla::ipc::ProtocolId sIds[] = {
        PJSValidatorMsgStart
    };
    return sIds;
}

auto PJSOracleChild::GetManagedActors(mozilla::ipc::ProtocolId aProtocol) -> UntypedManagedContainer*
{
    switch (aProtocol) {
    case PJSValidatorMsgStart:
        return (&(mManagedPJSValidatorChild));
    default:
        return nullptr;
    }
}

auto PJSOracleChild::OpenPJSValidatorEndpoint(PJSValidatorChild* aActor) -> ManagedEndpoint<PJSValidatorParent>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PJSValidatorChild actor");
        return ManagedEndpoint<PJSValidatorParent>();
    }

    if (!aActor->SetManagerAndRegister(this)) {
        NS_WARNING("Failed to bind PJSValidatorChild actor");
        return ManagedEndpoint<PJSValidatorParent>();
    }

    // Mark our actor as awaiting the other side to be bound. This will
    // be cleared when a `MANAGED_ENDPOINT_{DROPPED,BOUND}` message is
    // received.
    aActor->mAwaitingManagedEndpointBind = true;
    return ManagedEndpoint<PJSValidatorParent>(mozilla::ipc::PrivateIPDLInterface(), aActor);
}

auto PJSOracleChild::BindPJSValidatorEndpoint(
        ManagedEndpoint<PJSValidatorChild> aEndpoint,
        PJSValidatorChild* aActor) -> bool
{
    return aEndpoint.Bind(mozilla::ipc::PrivateIPDLInterface(), aActor, this);
}

auto PJSOracleChild::DeallocManagee(
        mozilla::ipc::ProtocolId aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    default:
        FatalError("unreached");
        return;
    }
}

auto PJSOracleChild::OnMessageReceived(const Message& msg__) -> PJSOracleChild::Result
{
    IPC::Message::routeid_t route__ = msg__.routing_id();
    if (MSG_ROUTING_CONTROL != route__) {
        IProtocol* routed__ = Lookup(route__);
        if (!routed__ || !routed__->GetLifecycleProxy()) {
            if (mozilla::ipc::LoggingEnabledFor("PJSOracle", mozilla::ipc::ChildSide)) {
                mozilla::ipc::LogMessageForProtocol(
                    "PJSOracleChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Ignored message for dead actor",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eSending);
            }
            return MsgProcessed;

        }

        RefPtr<mozilla::ipc::ActorLifecycleProxy> proxy__ =
            routed__->GetLifecycleProxy();
        return proxy__->Get()->OnMessageReceived(msg__);
    }

    switch (msg__.type()) {
    case PJSOracle::Msg_PJSValidatorConstructor__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PJSOracle", mozilla::ipc::ChildSide)) {
                mozilla::ipc::LogMessageForProtocol(
                    "PJSOracleChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PJSOracle::Msg_PJSValidatorConstructor", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__actorid__ = IPC::ReadParam<mozilla::ipc::ActorId>((&(reader__)));
            if (!maybe__actorid__) {
                FatalError("Error deserializing 'mozilla::ipc::ActorId'");
                return MsgValueError;

            }
            auto& actorid__ = *maybe__actorid__;
            // Sentinel = 'actorid'
            if ((!(((&(reader__)))->ReadSentinel(193725159)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'mozilla::ipc::ActorId'");
                return MsgValueError;
            }
            reader__.EndRead();
            RefPtr<PJSValidatorChild> actor = (static_cast<JSOracleChild*>(this))->AllocPJSValidatorChild();
            if (!actor) {
                NS_WARNING("Cannot bind null PJSValidatorChild actor");
                return MsgValueError;
            }

            if (!actor->SetManagerAndRegister(this, actorid__)) {
                NS_WARNING("Failed to bind PJSValidatorChild actor");
                return MsgValueError;
            }

            mozilla::ipc::IPCResult __ok = (static_cast<JSOracleChild*>(this))->RecvPJSValidatorConstructor(actor);
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    case SHMEM_CREATED_MESSAGE_TYPE:
        {
            if (!ShmemCreated(msg__)) {
                return MsgPayloadError;
            }
            return MsgProcessed;
        }
    case SHMEM_DESTROYED_MESSAGE_TYPE:
        {
            if (!ShmemDestroyed(msg__)) {
                return MsgPayloadError;
            }
            return MsgProcessed;
        }
    }
}

auto PJSOracleChild::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PJSOracleChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}



} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<::mozilla::dom::PJSOracleChild*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    IPC::WriteParam(aWriter, static_cast<mozilla::ipc::IProtocol*>(aVar));
    // Sentinel = 'PJSOracle'
    (aWriter)->WriteSentinel(258736964);
}

auto ParamTraits<::mozilla::dom::PJSOracleChild*>::Read(IPC::MessageReader* aReader) -> IPC::ReadResult<paramType>
{
    auto maybe__actor = IPC::ReadParam<mozilla::ipc::IProtocol*>(aReader);
    if (!maybe__actor) {
        aReader->FatalError("Error deserializing managed PJSOracle actor");
        return {};

    }
    auto& actor = *maybe__actor;
    // Sentinel = 'PJSOracle'
    if ((!((aReader)->ReadSentinel(258736964)))) {
        mozilla::ipc::SentinelReadError("Error deserializing managed PJSOracle actor");
        return {};
    }

    if (actor && actor->GetProtocolId() != PJSOracleMsgStart) {
        aReader->FatalError("Unexpected actor type (expected PJSOracle)");

        return {};
    }
    return static_cast<::mozilla::dom::PJSOracleChild*>(actor);
}

} // namespace IPC
