//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PMIDIManagerParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/MIDIManagerParent.h"


#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {


auto PMIDIManagerParent::ProcessingError(
        Result aCode,
        const char* aReason) -> void
{
}

auto PMIDIManagerParent::ShouldContinueFromReplyTimeout() -> bool
{
    return true;
}

MOZ_IMPLICIT PMIDIManagerParent::PMIDIManagerParent() :
    mozilla::ipc::IToplevelProtocol("PMIDIManagerParent", kProtocolId, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PMIDIManagerParent);
}

PMIDIManagerParent::~PMIDIManagerParent()
{
    MOZ_COUNT_DTOR(PMIDIManagerParent);
}

auto PMIDIManagerParent::ActorAlloc() -> void
{
    MOZ_RELEASE_ASSERT(XRE_IsParentProcess(), "Invalid process for `PMIDIManagerParent'");
    AddRef();
}

auto PMIDIManagerParent::ActorDealloc() -> void
{
    Release();
}

auto PMIDIManagerParent::ManagedProtocolIds() const -> mozilla::Span<mozilla::ipc::ProtocolId const>
{
    return {};
}

auto PMIDIManagerParent::GetManagedActors(mozilla::ipc::ProtocolId aProtocol) -> UntypedManagedContainer*
{
    switch (aProtocol) {
    default:
        return nullptr;
    }
}

auto PMIDIManagerParent::SendMIDIPortListUpdate(const MIDIPortList& aPortList) -> bool
{
    UniquePtr<IPC::Message> msg__ = PMIDIManager::Msg_MIDIPortListUpdate(MSG_ROUTING_CONTROL);
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), aPortList);
    // Sentinel = 'aPortList'
    ((&(writer__)))->WriteSentinel(296747939);


    if (mozilla::ipc::LoggingEnabledFor("PMIDIManager", mozilla::ipc::ParentSide)) {
        mozilla::ipc::LogMessageForProtocol(
            "PMIDIManagerParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PMIDIManager::Msg_MIDIPortListUpdate", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PMIDIManagerParent::DeallocManagee(
        mozilla::ipc::ProtocolId aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PMIDIManagerParent::OnMessageReceived(const Message& msg__) -> PMIDIManagerParent::Result
{
    switch (msg__.type()) {
    case PMIDIManager::Msg_Refresh__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PMIDIManager", mozilla::ipc::ParentSide)) {
                mozilla::ipc::LogMessageForProtocol(
                    "PMIDIManagerParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PMIDIManager::Msg_Refresh", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<MIDIManagerParent*>(this))->RecvRefresh();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMIDIManager::Msg_Shutdown__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PMIDIManager", mozilla::ipc::ParentSide)) {
                mozilla::ipc::LogMessageForProtocol(
                    "PMIDIManagerParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PMIDIManager::Msg_Shutdown", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<MIDIManagerParent*>(this))->RecvShutdown();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    case SHMEM_CREATED_MESSAGE_TYPE:
        {
            if (!ShmemCreated(msg__)) {
                return MsgPayloadError;
            }
            return MsgProcessed;
        }
    case SHMEM_DESTROYED_MESSAGE_TYPE:
        {
            if (!ShmemDestroyed(msg__)) {
                return MsgPayloadError;
            }
            return MsgProcessed;
        }
    }
}

auto PMIDIManagerParent::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PMIDIManagerParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}



} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<::mozilla::dom::PMIDIManagerParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    IPC::WriteParam(aWriter, static_cast<mozilla::ipc::IProtocol*>(aVar));
    // Sentinel = 'PMIDIManager'
    (aWriter)->WriteSentinel(421332015);
}

auto ParamTraits<::mozilla::dom::PMIDIManagerParent*>::Read(IPC::MessageReader* aReader) -> IPC::ReadResult<paramType>
{
    auto maybe__actor = IPC::ReadParam<mozilla::ipc::IProtocol*>(aReader);
    if (!maybe__actor) {
        aReader->FatalError("Error deserializing managed PMIDIManager actor");
        return {};

    }
    auto& actor = *maybe__actor;
    // Sentinel = 'PMIDIManager'
    if ((!((aReader)->ReadSentinel(421332015)))) {
        mozilla::ipc::SentinelReadError("Error deserializing managed PMIDIManager actor");
        return {};
    }

    if (actor && actor->GetProtocolId() != PMIDIManagerMsgStart) {
        aReader->FatalError("Unexpected actor type (expected PMIDIManager)");

        return {};
    }
    return static_cast<::mozilla::dom::PMIDIManagerParent*>(actor);
}

} // namespace IPC
